/*
 * $Id: dx64HPIcomm.h 20 2006-01-23 14:33:45Z herout $
 */

#ifndef _dx64HPIcomm_h_
#define _dx64HPIcomm_h_

#define HPIC_BASE             0x10000
#define FU_BASE               0x20000


#define HPIC_STATUS           (HPIC_BASE + 0x00)
#define HPIC_VERSION          (HPIC_BASE + 0x04)
#define HPIC_TEST             (HPIC_BASE + 0x08)

#define HPIC_DMAfromDSP_SIZE  (HPIC_BASE + 0x10)
#define HPIC_DMAfromDSP_CHID  (HPIC_BASE + 0x14)
#define HPIC_DMAfromDSP_PCPTR (HPIC_BASE + 0x18)

#define HPIC_DMAtoDSP_SIZE    (HPIC_BASE + 0x20)
#define HPIC_DMAtoDSP_CHID    (HPIC_BASE + 0x24)
#define HPIC_DMAtoDSP_PCPTR   (HPIC_BASE + 0x28)

#define HPIC_PROF_A           (HPIC_BASE + 0x30)
#define HPIC_PROF_B           (HPIC_BASE + 0x34)
#define HPIC_PROF_C           (HPIC_BASE + 0x38)
#define HPIC_PROF_D           (HPIC_BASE + 0x3C)

#define FU_SIZE               (FU_BASE + 0x000)
#define FU_POINTER            (FU_BASE + 0x004)

#define FU_STATUS             (FU_BASE + 0x400)
#define FU_RUN                (FU_BASE + 0x404)
#define FU_SIZE_IN            (FU_BASE + 0x408)
#define FU_ADDR_IN            (FU_BASE + 0x40C)
#define FU_POINTER_IN         (FU_BASE + 0x410)


// size of buffer in DWORDs
#define DBG_BUFF_SIZE		1024

// addresses
#define DBG_SIZE_PTR		(0x200)
#define DBG_BUFF_PTR		(0x204)
#define DBG_FIRST_PTR		(0x208)
#define DBG_LAST_PTR		(0x20C)





#ifdef __DX64__
# define hpicAccess(X)   (*((volatile unsigned *)(X)))
#else
extern unsigned dummy;
# define hpicAccess(X)   dummy
#endif

// ==================================================
// ==================================================
//   communication   communication   communication
// ==================================================



// ==================================================
// DX64profiling  DX64profiling  DX64profiling
// ==================================================
// DX64profiling  DX64profiling  DX64profiling
// ==================================================
// DX64profiling  DX64profiling  DX64profiling
// ==================================================
// DX64profiling  DX64profiling  DX64profiling

# define FPGA_TIMER     ((volatile unsigned *) 0x68000040)

//#define DISABLE_PROFILING

#if defined(__DX64__) && !defined(DISABLE_PROFILING)

# define profX()  ((*FPGA_TIMER) = 0)
# define profA()  ((hpicAccess(HPIC_PROF_A) += (*FPGA_TIMER)), ((*FPGA_TIMER) = 0))
# define profB()  ((hpicAccess(HPIC_PROF_B) += (*FPGA_TIMER)), ((*FPGA_TIMER) = 0))
# define profC()  ((hpicAccess(HPIC_PROF_C) += (*FPGA_TIMER)), ((*FPGA_TIMER) = 0))
# define profD()  ((hpicAccess(HPIC_PROF_D) += (*FPGA_TIMER)), ((*FPGA_TIMER) = 0))

#else
# define profX()  ((void)0)
# define profA()  ((void)0)
# define profB()  ((void)0)
# define profC()  ((void)0)
# define profD()  ((void)0)
#endif


#endif
