#ifndef COMMUNICATION_DEFINES_H
#define COMMUNICATION_DEFINES_H

#ifdef __DX64__
# define hpicAccess(X)   (*((volatile unsigned *)(X)))
#else
extern unsigned dummy;
# define hpicAccess(X)   dummy
#endif

#define SOBEL_BASE 0x200

#define SOBEL_INPUT           (SOBEL_BASE)
#define SOBEL_OUTPUT          (SOBEL_BASE + 0x04)
#define SOBEL_DATA_IN_LEN     (SOBEL_BASE + 0x08)
#define SOBEL_DATA_IN_READY   (SOBEL_BASE + 0x0C)
#define SOBEL_READY_REG       (SOBEL_BASE + 0x10)
#define SOBEL_DONE            (SOBEL_BASE + 0x14)
#define SOBEL_DATA_OUT_READY  (SOBEL_BASE + 0x18)
#define SOBEL_DATA_OUT_LEN    (SOBEL_BASE + 0x1C)


#endif

