;
;  Copyright 2001 by Texas Instruments Incorporated.
;  All rights reserved. Property of Texas Instruments Incorporated.
;  Restricted rights to use, duplicate or disclose this code are
;  granted through contract.
;  U.S. Patent Nos. 5,283,900  5,392,448
;
; "@(#) DSP/BIOS 4.51.0 05-23-01 (barracuda-i10)"
;
;  ======== vectors.asm ========
;  Plug in the entry point at RESET in the interrupt vector table
;
;
;  ======== unused ========
;  plug inifinite loop -- with nested branches to
;  disable interrupts -- for all undefined vectors
;
unused  .macro id

        .global vector:id:
vector:id:
        b vector:id:    ; nested branches to block interrupts
        nop 4
        b vector:id:
        nop
        nop
        nop
        nop
        nop

        .endm

        .sect ".vectors"

        .ref _c_int00           ; C entry point
        .ref _IsrExtInt4
        .ref _IsrEdmaInt
		.ref _timer1_ISR

        .align  32*8*4          ; must be aligned on 256 word boundary

RESET:                          ; reset vector
        mvkl _c_int00,b0        ; load destination function address to b0
        mvkh _c_int00,b0
        b b0                    ; start branch to destination function
        mvc PCE1,b0             ; address of interrupt vectors
        mvc b0,ISTP             ; set table to point here
        nop 3                   ; fill delay slot
        nop
        nop

NMI:
		b RESET
		nop 5
		nop
		nop
		nop
		nop
		nop
		nop
        ;
        ;  plug unused interrupts with infinite loops to
        ;  catch stray interrupts
        ;    
        unused 2
        unused 3

; external interrupt        
INT4:
       mvkl _IsrExtInt4,b0        ; load destination function address to b0
       mvkh _IsrExtInt4,b0
       b b0                    ; start branch to destination function
       nop 5
       nop
       nop 
       nop
       nop


        unused 5
        unused 6
        unused 7

; EDMA transfer complete interrupt        
INT8:
        mvkl _IsrEdmaInt,b0        ; load destination function address to b0
        mvkh _IsrEdmaInt,b0
        b b0                    ; start branch to destination function
        nop 5
        nop
        nop 
        nop
        nop

		
        unused 9
        unused 10
        unused 11
        unused 12
        unused 13
        unused 14
INT15:
        mvkl _timer1_ISR,b0        ; load destination function address to b0
        mvkh _timer1_ISR,b0
        b b0                    ; start branch to destination function
        nop 5
        nop
        nop 
        nop
        nop

;        unused 15

